package com.diagbot.client.hystrix;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.diagbot.client.CdssClient;
import com.diagbot.dto.RespDTO;
import com.diagbot.entity.MappingConfig;
import com.diagbot.entity.wrapper.MappingConfigWrapper;
import com.diagbot.vo.IdListVO;
import com.diagbot.vo.IdVO;
import com.diagbot.vo.MappingConfigPageVO;
import com.diagbot.vo.MappingConfigVO;
import feign.FeignException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.List;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2021/6/21 15:33
 */
@Component
@Slf4j
public class CdssHystrix implements CdssClient {
    @Override
    public void exportExcelModule(@Valid MappingConfigVO mappingConfigVO) {
        log.error("【hystrix】调用{}异常", "exportExcelModule");
    }

    @Override
    public RespDTO<Boolean> dataVerify(@RequestParam("file") MultipartFile file,
                                       @RequestParam("type") Integer type) {
        log.error("【hystrix】调用{}异常", "dataVerify");
        return null;
    }

    @Override
    public void precDataMatch(MultipartFile file, HttpServletResponse response, Integer type) {
        log.error("【hystrix】调用{}异常", "precDataMatch");
    }

    @Override
    public RespDTO<List<MappingConfigWrapper>> precDataMatch_remote(@RequestPart("file") MultipartFile file,
                                                                    @RequestParam("type") Integer type) throws FeignException {
        log.error("【hystrix】调用{}异常", "precDataMatch_remote");
        return null;
    }

    @Override
    public void importExcel(MultipartFile file, Long hospitalId, Integer type, String userId) {
        log.error("【hystrix】调用{}异常", "importExcel");
    }

    @Override
    public RespDTO<List<MappingConfigWrapper>> exportExcel_remote(@RequestBody @Valid MappingConfigPageVO mappingConfigPageVO) {
        log.error("【hystrix】调用{}异常", "exportExcel_remote");
        return null;
    }

    @Override
    public RespDTO<Page<MappingConfigWrapper>> getPage(@Valid MappingConfigPageVO mappingConfigPageVO) {
        log.error("【hystrix】调用{}异常", "getPage");
        return null;
    }

    @Override
    public RespDTO<MappingConfigWrapper> getRecord(@Valid IdVO idVO) {
        log.error("【hystrix】调用{}异常", "getRecord");
        return null;
    }

    @Override
    public RespDTO<Boolean> isExistRecord(@Valid MappingConfig mappingConfig) {
        log.error("【hystrix】调用{}异常", "isExistRecord");
        return null;
    }

    @Override
    public RespDTO<List<MappingConfigWrapper>> getRelatedMapping(@Valid MappingConfigVO mappingConfigVO) {
        log.error("【hystrix】调用{}异常", "getRelatedMapping");
        return null;
    }

    @Override
    public RespDTO<Boolean> saveOrUpdateRecord(@Valid MappingConfig mappingConfig) {
        log.error("【hystrix】调用{}异常", "saveOrUpdateRecord");
        return null;
    }

    @Override
    public RespDTO<Boolean> deleteRecord(@Valid IdVO idVO) {
        log.error("【hystrix】调用{}异常", "deleteRecord");
        return null;
    }

    @Override
    public RespDTO<Boolean> deleteRecords(@Valid IdListVO idListVO) {
        log.error("【hystrix】调用{}异常", "deleteRecords");
        return null;
    }
}