package com.diagbot.dto;

import com.google.common.collect.Lists;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 疾病表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-11
 */
@Data
public class KlDiseaseDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 科室概念id
     */
    private Long deptId;

    /**
     * ICD10编号
     */
    private String icd10Code;

    /**
     * 病程
     */
    private String course;

    /**
     * 诱因
     */
    private String inducement;

    /**
     * 饮食禁忌
     */
    private String foodProhibition;

    /**
     * 危险因素
     */
    private String hazard;

    /**
     * 治愈性
     */
    private String healing;

    /**
     * 危害性
     */
    private String pernicious;

    /**
     * 临床分类
     */
    private String clinicType;

    /**
     * 好发地区
     */
    private String vulArea;

    /**
     * 好发人群
     */
    private String vulCrowd;

    /**
     * 发病率
     */
    private Double incidence;

    /**
     * 是否传染（0：否，1：是）
     */
    private Integer isInfect;

    /**
     * 并发症
     */
    private String complication;

    /**
     * 病因
     */
    private String pathogeny;

    /**
     * 疾病分型
     */
    private String disType;

    /**
     * 中西医疾病（0：通用，1：西，2：中）
     */
    private Integer chWestern;

    /**
     * 是否常见病（0：否，1：是）
     */
    private Integer isCommonDis;

    /**
     * 是否遗传（0：否，1：是）
     */
    private Integer isHeredity;

    /**
     * 简称
     */
    private String nameSimple;

    /**
     * 英文简称
     */
    private String enNameSimple;

    /**
     * 英文名称
     */
    private String enName;

    /**
     * 肿瘤细胞类型
     */
    private String tumorCellType;

    /**
     * 形态学分类代码
     */
    private String morphology;

    // 科室列表
    private List<KlConceptSimDTO> deptList = Lists.newLinkedList();

    // 部位列表
    private List<KlConceptSimDTO> partList = Lists.newLinkedList();

    // 疾病系统分类列表
    private List<KlConceptSimDTO> systemTypeList = Lists.newLinkedList();

}
