package com.diagbot.dto;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 药品注册表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-11
 */
@Data
public class KlDrugRegisterDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    private Long id;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private Date gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

    /**
     * 药品代码
     */
    private String drugCode;

    /**
     * 注册名称
     */
    private String name;

    /**
     * 英文名称
     */
    private String enName;

    /**
     * 商品名称
     */
    private String tradeName;

    /**
     * 药品剂型
     */
    private String form;

    /**
     * 注册规格
     */
    private String specification;

    /**
     * 最小包装数量
     */
    private String minPackQuantity;

    /**
     * 最小包装单位
     */
    private String minPackUnit;

    /**
     * 药品企业
     */
    private String company;

    /**
     * 批准文号
     */
    private String approval;

    /**
     * 药品本位码
     */
    private String standardCode;

    /**
     * 医保类型
     */
    private String insuranceType;

    /**
     * 医保备注
     */
    private String insuranceRemrk;

    /**
     * 药品类别
     */
    private String drugType;

    /**
     * 备注
     */
    private String remark;

    /**
     * 药品通用名
     */
    private Long drugConceptId;

    /**
     * 药品通用名
     */
    private String drugName;
}
