package com.diagbot.dto;

import com.google.common.collect.Lists;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 症状扩展表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-12
 */
@Data
public class KlSymptomDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 阳性症状（0：否，1：是）
     */
    private Integer isPositive;

    /**
     * 英文名称
     */
    private String enName;

    /**
     * 定义
     */
    private String definition;

    /**
     * 中西医症状（0：通用，1：西，2：中）
     */
    private Integer chWestern;

    /**
     * 缓解因素
     */
    private String mitigatingFac;

    /**
     * 加重因素
     */
    private String aggravateFac;

    /**
     * 症状起因
     */
    private String cause;

    /**
     * 常见疾病
     */
    private String commonDis;

    /**
     * 预防措施
     */
    private String preMeasures;

    /**
     * 饮食禁忌
     */
    private String foodProhibition;

    /**
     * 通俗解释
     */
    private String commonExplain;

    // 科室列表
    private List<KlConceptSimDTO> deptList = Lists.newLinkedList();

    // 部位列表
    private List<KlConceptSimDTO> partList = Lists.newLinkedList();

    // 常见伴随症状列表
    private List<KlConceptSimDTO> conSymptomList = Lists.newLinkedList();

    // 性质列表
    private List<KlConceptSimDTO> natureList = Lists.newLinkedList();

}
