package com.diagbot.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 药品通用名和注册名映射表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-11
 */
@Data
public class KlDrugMapping implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private Date gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

    /**
     * 药品通用名conceptId
     */
    private Long drugConcept;

    /**
     * 药品注册名Id
     */
    private Long registerId;

    /**
     * 顺序号
     */
    private Integer orderNo;

    /**
     * 备注
     */
    private String remark;
}
