package com.diagbot.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 药品注册表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-11
 */
public class KlDrugRegister implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private Date gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

    /**
     * 药品代码
     */
    private String drugCode;

    /**
     * 注册名称
     */
    private String name;

    /**
     * 英文名称
     */
    private String enName;

    /**
     * 商品名称
     */
    private String tradeName;

    /**
     * 药品剂型
     */
    private String form;

    /**
     * 注册规格
     */
    private String specification;

    /**
     * 最小包装数量
     */
    private String minPackQuantity;

    /**
     * 最小包装单位
     */
    private String minPackUnit;

    /**
     * 药品企业
     */
    private String company;

    /**
     * 批准文号
     */
    private String approval;

    /**
     * 药品本位码
     */
    private String standardCode;

    /**
     * 医保类型
     */
    private String insuranceType;

    /**
     * 医保备注
     */
    private String insuranceRemrk;

    /**
     * 药品类别
     */
    private String drugType;

    /**
     * 备注
     */
    private String remark;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    public String getIsDeleted() {
        return isDeleted;
    }

    public void setIsDeleted(String isDeleted) {
        this.isDeleted = isDeleted;
    }
    public Date getGmtCreate() {
        return gmtCreate;
    }

    public void setGmtCreate(Date gmtCreate) {
        this.gmtCreate = gmtCreate;
    }
    public Date getGmtModified() {
        return gmtModified;
    }

    public void setGmtModified(Date gmtModified) {
        this.gmtModified = gmtModified;
    }
    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }
    public String getModifier() {
        return modifier;
    }

    public void setModifier(String modifier) {
        this.modifier = modifier;
    }
    public String getDrugCode() {
        return drugCode;
    }

    public void setDrugCode(String drugCode) {
        this.drugCode = drugCode;
    }
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    public String getEnName() {
        return enName;
    }

    public void setEnName(String enName) {
        this.enName = enName;
    }
    public String getTradeName() {
        return tradeName;
    }

    public void setTradeName(String tradeName) {
        this.tradeName = tradeName;
    }
    public String getForm() {
        return form;
    }

    public void setForm(String form) {
        this.form = form;
    }
    public String getSpecification() {
        return specification;
    }

    public void setSpecification(String specification) {
        this.specification = specification;
    }
    public String getMinPackQuantity() {
        return minPackQuantity;
    }

    public void setMinPackQuantity(String minPackQuantity) {
        this.minPackQuantity = minPackQuantity;
    }
    public String getMinPackUnit() {
        return minPackUnit;
    }

    public void setMinPackUnit(String minPackUnit) {
        this.minPackUnit = minPackUnit;
    }
    public String getCompany() {
        return company;
    }

    public void setCompany(String company) {
        this.company = company;
    }
    public String getApproval() {
        return approval;
    }

    public void setApproval(String approval) {
        this.approval = approval;
    }
    public String getStandardCode() {
        return standardCode;
    }

    public void setStandardCode(String standardCode) {
        this.standardCode = standardCode;
    }
    public String getInsuranceType() {
        return insuranceType;
    }

    public void setInsuranceType(String insuranceType) {
        this.insuranceType = insuranceType;
    }
    public String getInsuranceRemrk() {
        return insuranceRemrk;
    }

    public void setInsuranceRemrk(String insuranceRemrk) {
        this.insuranceRemrk = insuranceRemrk;
    }
    public String getDrugType() {
        return drugType;
    }

    public void setDrugType(String drugType) {
        this.drugType = drugType;
    }
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Override
    public String toString() {
        return "KlDrugRegister{" +
            "id=" + id +
            ", isDeleted=" + isDeleted +
            ", gmtCreate=" + gmtCreate +
            ", gmtModified=" + gmtModified +
            ", creator=" + creator +
            ", modifier=" + modifier +
            ", drugCode=" + drugCode +
            ", name=" + name +
            ", enName=" + enName +
            ", tradeName=" + tradeName +
            ", form=" + form +
            ", specification=" + specification +
            ", minPackQuantity=" + minPackQuantity +
            ", minPackUnit=" + minPackUnit +
            ", company=" + company +
            ", approval=" + approval +
            ", standardCode=" + standardCode +
            ", insuranceType=" + insuranceType +
            ", insuranceRemrk=" + insuranceRemrk +
            ", drugType=" + drugType +
            ", remark=" + remark +
        "}";
    }
}
