package com.diagbot.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 概念通用扩展表
 * </p>
 *
 * @author wangfeng
 * @since 2021-03-01
 */
@Setter
@Getter
public class KlLis implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private Date gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

    /**
     * 术语概念id
     */
    private Long conceptId;

    /**
     * 最小值
     */
    private Double minValue;

    /**
     * 最大值
     */
    private Double maxValue;

    /**
     * 类型(0:范围内;1:范围外)
     */
    private Integer type;

    /**
     * 单位概念id
     */

    private String unit;

    /**
     * 检查标本
     */
    private String checkSpecimen;

    /**
     * 检查方法
     */
    private String checkMethod;

    /**
     * 影响因素
     */
    private String influenceFac;

    /**
     * 临床意义
     */
    private String clinicalSig;

    /**
     * 定性（阴、阳性）
     */
    private String qualitative;

    /**
     * 所属类别
     */
    private String category;

    /**
     * 英文名称
     */
    private String enName;

    /**
     * 备注
     */
    private String remark;



    @Override
    public String toString() {
        return "KlLis{" +
            "id=" + id +
            ", isDeleted=" + isDeleted +
            ", gmtCreate=" + gmtCreate +
            ", gmtModified=" + gmtModified +
            ", creator=" + creator +
            ", modifier=" + modifier +
            ", conceptId=" + conceptId +
            ", minValue=" + minValue +
            ", maxValue=" + maxValue +
            ", type=" + type +
            ", unit=" + unit +
            ", remark=" + remark +
        "}";
    }
}
