package com.diagbot.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 辅检扩展表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-12
 */
@Data
public class KlPacs implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private Date gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

    /**
     * 术语概念id
     */
    private Long conceptId;

    /**
     * 检查方法
     */
    private String checkMethod;

    /**
     * 项目定义
     */
    private String definition;

    /**
     * 检查目的
     */
    private String checkObjective;

    /**
     * 检查技术
     */
    private String checkSkillful;

    /**
     * 禁忌症和局限性
     */
    private String condLimit;

    /**
     * 适应症
     */
    private String interventional;

    /**
     * 危急标识（0：不危急，1：危急）
     */
    private Integer emergencySign;

    /**
     * 检查前准备
     */
    private String checkPrepare;

    /**
     * 备注
     */
    private String remark;



    @Override
    public String toString() {
        return "KlPacs{" +
            "id=" + id +
            ", isDeleted=" + isDeleted +
            ", gmtCreate=" + gmtCreate +
            ", gmtModified=" + gmtModified +
            ", creator=" + creator +
            ", modifier=" + modifier +
            ", conceptId=" + conceptId +
            ", checkMethod=" + checkMethod +
            ", definition=" + definition +
            ", checkObjective=" + checkObjective +
            ", checkSkillful=" + checkSkillful +
            ", condLimit=" + condLimit +
            ", interventional=" + interventional +
            ", emergencySign=" + emergencySign +
            ", checkPrepare=" + checkPrepare +
            ", remark=" + remark +
        "}";
    }
}
