package com.diagbot.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 症状扩展表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-12
 */
@Data
public class KlSymptom implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private Date gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

    /**
     * 术语概念id
     */
    private Long conceptId;

    /**
     * 阳性症状（0：否，1：是）
     */
    private Integer isPositive;

    /**
     * 英文名称
     */
    private String enName;

    /**
     * 定义
     */
    private String definition;

    /**
     * 中西医症状（0：通用，1：西，2：中）
     */
    private Integer chWestern;

    /**
     * 缓解因素
     */
    private String mitigatingFac;

    /**
     * 加重因素
     */
    private String aggravateFac;

    /**
     * 症状起因
     */
    private String cause;

    /**
     * 常见疾病
     */
    private String commonDis;

    /**
     * 预防措施
     */
    private String preMeasures;

    /**
     * 饮食禁忌
     */
    private String foodProhibition;

    /**
     * 通俗解释
     */
    private String commonExplain;

    /**
     * 备注
     */
    private String remark;
}
