package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.KlConceptAllDTO;
import com.diagbot.dto.KlDrugDTO;
import com.diagbot.entity.CommonParam;
import com.diagbot.entity.KlDrug;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.KlDrugServiceImpl;
import com.diagbot.vo.KlDrugVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author wangfeng
 * @Description:
 * @date 2021-04-13 10:41
 */
@Component
public class KlDrugFacade extends KlDrugServiceImpl {

    @Autowired
    KlDrugRegisterFacade klDrugRegisterFacade;

    /**
     * 疾病扩展获取
     *
     * @param conceptId
     * @param klConceptAllDTO
     */
    public void getKlDrug(Long conceptId, KlConceptAllDTO klConceptAllDTO) {
        KlDrugDTO klDrugDTO = new KlDrugDTO();

        // 获取药品类别（0：西药，1：中成药）
        KlDrug klDrug = this.getOne(new QueryWrapper<KlDrug>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", conceptId), false);
        if (klDrug != null) {
            klDrugDTO.setDrug(klDrug.getDrug());
        }

        // 获取关联注册药品信息（这里先不展示关联的注册药品）
        // KlDrugMappingGetVO klDrugMappingGetVO = new KlDrugMappingGetVO();
        // klDrugMappingGetVO.setDrugConcept(conceptId);
        // List<KlDrugMappingDTO> klDrugMappingDTOList = klDrugRegisterFacade.getMappingRegister(klDrugMappingGetVO);
        // klDrugDTO.setKlDrugMappingDTOList(klDrugMappingDTOList);

        klConceptAllDTO.setKlDrugDTO(klDrugDTO);
    }

    /**
     *
     * @param commonParam
     * @param klDrugVO
     */
    public void saveKlDrug(CommonParam commonParam, KlDrugVO klDrugVO) {
        // 先删除
        this.remove(new QueryWrapper<KlDrug>().eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", commonParam.getConceptId()));

        if (klDrugVO != null) {
            KlDrug klDrug = new KlDrug();
            klDrug.setConceptId(commonParam.getConceptId());
            klDrug.setDrug(klDrugVO.getDrug());
            klDrug.setCreator(commonParam.getPerson());
            klDrug.setModifier(commonParam.getPerson());
            klDrug.setGmtCreate(commonParam.getNow());
            klDrug.setGmtModified(commonParam.getNow());
            this.save(klDrug);
        }
    }

}
