package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.diagbot.dto.KlConceptAllDTO;
import com.diagbot.dto.KlLisDTO;
import com.diagbot.entity.CommonParam;
import com.diagbot.entity.KlConcept;
import com.diagbot.entity.KlDisease;
import com.diagbot.entity.KlLis;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.KlLisServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.DateUtil;
import com.diagbot.util.UserUtils;
import com.diagbot.vo.KlConceptSaveVO;
import com.diagbot.vo.KlDiseaseVO;
import com.diagbot.vo.KlLisVO;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @author wangfeng
 * @Description:
 * @date 2021-03-18 16:38
 */
@Component
public class KlLisFacade extends KlLisServiceImpl {

    /*public boolean saveOrUpdateAll(KlConceptSaveVO klConceptSaveVO) {
        Date now = DateUtil.now();
        boolean res = false;
        if (null != klConceptSaveVO.getConceptId()) {
            //校验
            int countLis = this.count(new QueryWrapper<KlLis>()
                    .eq("is_deleted", IsDeleteEnum.N.getKey())
                    .eq("concept_id", klConceptSaveVO.getConceptId()));
            if (countLis > 0) {
                UpdateWrapper<KlLis> klDiseaseQuerySub = new UpdateWrapper<>();
                klDiseaseQuerySub.eq("is_deleted", IsDeleteEnum.N.getKey())
                        .eq("concept_id", klConceptSaveVO.getConceptId())
                        .set("gmt_modified", now)
                        .set("modifier", UserUtils.getCurrentPrincipleID())
                        .set("min_value", klConceptSaveVO.getMinVal())
                        .set("max_value", klConceptSaveVO.getMaxVal())
                        .set("unit", klConceptSaveVO.getUnit())
                        .set("type", klConceptSaveVO.getScopeType());
                res = this.update(new KlLis(), klDiseaseQuerySub);
            } else {
                KlLis klLisSub = new KlLis();
                klLisSub.setConceptId(klConceptSaveVO.getConceptId());
                klLisSub.setGmtModified(now);
                klLisSub.setUnit(klConceptSaveVO.getUnit());
                klLisSub.setModifier(UserUtils.getCurrentPrincipleID());
                klLisSub.setMinValue(klConceptSaveVO.getMinVal());
                klLisSub.setMaxValue(klConceptSaveVO.getMaxVal());
                klLisSub.setType(klConceptSaveVO.getScopeType());
                res = this.save(klLisSub);
            }

        } else {
            KlLis klLisSub = new KlLis();
            klLisSub.setConceptId(klConceptSaveVO.getConceptId());
            klLisSub.setGmtModified(now);
            klLisSub.setUnit(klConceptSaveVO.getUnit());
            klLisSub.setModifier(UserUtils.getCurrentPrincipleID());
            klLisSub.setMinValue(klConceptSaveVO.getMinVal());
            klLisSub.setMaxValue(klConceptSaveVO.getMaxVal());
            klLisSub.setType(klConceptSaveVO.getScopeType());
            res = this.save(klLisSub);
        }
        return res;
    }

    public boolean saveAll(KlConcept klConceptPare, KlConceptSaveVO klConceptSaveVO) {
        Date now = DateUtil.now();
        KlLis klLisSub = new KlLis();
        klLisSub.setConceptId(klConceptPare.getId());
        klLisSub.setMinValue(klConceptSaveVO.getMinVal());
        klLisSub.setMaxValue(klConceptSaveVO.getMaxVal());
        klLisSub.setUnit(klConceptSaveVO.getUnit());
        klLisSub.setType(klConceptSaveVO.getScopeType());
        klLisSub.setCreator(UserUtils.getCurrentPrincipleID());
        klLisSub.setModifier(UserUtils.getCurrentPrincipleID());
        klLisSub.setGmtCreate(now);
        klLisSub.setGmtModified(now);
        return this.save(klLisSub);
    }*/

    /**
     * 保存化验扩展表
     *
     * @param commonParam
     * @param klLisVO
     * @return
     */
    public boolean saveAll(CommonParam commonParam, KlLisVO klLisVO) {
        if(klLisVO == null){
            return false;
        }
        // 先删除疾病扩展表
        this.remove(new QueryWrapper<KlLis>().eq("concept_id", commonParam.getConceptId()));
        // 重新插入扩展表
        KlLis klLis = new KlLis();
        BeanUtil.copyProperties(klLisVO, klLis);
        klLis.setConceptId(commonParam.getConceptId());
        klLis.setGmtModified(commonParam.getNow());
        klLis.setGmtCreate(commonParam.getNow());
        klLis.setCreator(commonParam.getPerson());
        klLis.setModifier(commonParam.getPerson());
        return this.save(klLis);
    }

    public void getKlLis(Long conceptId, KlConceptAllDTO klConceptAll) {
        KlLis klLis = this.getOne(new QueryWrapper<KlLis>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", conceptId), false);
        if (klLis == null) {
            return;
        }
        KlLisDTO klLisDTO = new KlLisDTO();
        BeanUtil.copyProperties(klLis,klLisDTO);
        klConceptAll.setKlLisDTO(klLisDTO);
    }
}
