package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.KlConceptAllDTO;
import com.diagbot.dto.KlOperationDTO;
import com.diagbot.entity.CommonParam;
import com.diagbot.entity.KlOperation;
import com.diagbot.entity.KlPacs;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.KlOperationServiceImpl;
import com.diagbot.service.impl.KlPacsServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.vo.KlOperationVO;
import com.diagbot.vo.KlPacsVO;
import org.springframework.stereotype.Component;

/**
 * @author kwz
 * @Description:
 * @date 2021-03-18 16:38
 */
@Component
public class KlOperationFacade extends KlOperationServiceImpl {



    /**
     * 保存手术扩展表
     *
     * @param commonParam
     * @param klOperationVO
     * @return
     */
    public boolean saveAll(CommonParam commonParam, KlOperationVO klOperationVO) {
        if(klOperationVO == null){
            return false;
        }
        // 先删除手术扩展表
        this.remove(new QueryWrapper<KlOperation>().eq("concept_id", commonParam.getConceptId()));
        // 重新插入扩展表
        KlOperation klOperation = new KlOperation();
        BeanUtil.copyProperties(klOperationVO, klOperation);
        klOperation.setConceptId(commonParam.getConceptId());
        klOperation.setGmtModified(commonParam.getNow());
        klOperation.setGmtCreate(commonParam.getNow());
        klOperation.setCreator(commonParam.getPerson());
        klOperation.setModifier(commonParam.getPerson());
        return this.save(klOperation);
    }

    public void getKlOperation(Long conceptId, KlConceptAllDTO klConceptAll) {
        KlOperation klOperation = this.getOne(new QueryWrapper<KlOperation>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", conceptId), false);
        if(klOperation == null){
            return;
        }
        KlOperationDTO klOperationDTO = new KlOperationDTO();
        BeanUtil.copyProperties(klOperation,klOperationDTO);
        klConceptAll.setKlOperationDTO(klOperationDTO);
    }
}
