package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.diagbot.dto.KlConceptAllDTO;
import com.diagbot.dto.KlPacsDTO;
import com.diagbot.entity.CommonParam;
import com.diagbot.entity.KlConcept;
import com.diagbot.entity.KlLis;
import com.diagbot.entity.KlPacs;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.KlLisServiceImpl;
import com.diagbot.service.impl.KlPacsServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.DateUtil;
import com.diagbot.util.UserUtils;
import com.diagbot.vo.KlConceptSaveVO;
import com.diagbot.vo.KlLisVO;
import com.diagbot.vo.KlPacsVO;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @author kwz
 * @Description:
 * @date 2021-03-18 16:38
 */
@Component
public class KlPacsFacade extends KlPacsServiceImpl {



    /**
     * 保存辅检扩展表
     *
     * @param commonParam
     * @param klPacsVO
     * @return
     */
    public boolean saveAll(CommonParam commonParam, KlPacsVO klPacsVO) {
        if(klPacsVO == null){
            return false;
        }
        // 先删除辅检扩展表
        this.remove(new QueryWrapper<KlPacs>().eq("concept_id", commonParam.getConceptId()));
        // 重新插入扩展表
        KlPacs klPacs = new KlPacs();
        BeanUtil.copyProperties(klPacsVO, klPacs);
        klPacs.setConceptId(commonParam.getConceptId());
        klPacs.setGmtModified(commonParam.getNow());
        klPacs.setGmtCreate(commonParam.getNow());
        klPacs.setCreator(commonParam.getPerson());
        klPacs.setModifier(commonParam.getPerson());
        return this.save(klPacs);
    }

    public void getKlPacs(Long conceptId, KlConceptAllDTO klConceptAll) {
        KlPacs klPacs = this.getOne(new QueryWrapper<KlPacs>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", conceptId), false);
        if(klPacs == null){
            return;
        }
        KlPacsDTO klPacsDTO = new KlPacsDTO();
        BeanUtil.copyProperties(klPacs,klPacsDTO);
        klConceptAll.setKlPacsDTO(klPacsDTO);

    }
}
