package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.KlConceptAllDTO;
import com.diagbot.dto.KlTcmDiseaseDTO;
import com.diagbot.entity.CommonParam;
import com.diagbot.entity.KlTcmDisease;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.KlTcmDiseaseServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.vo.KlTcmDiseaseVO;
import org.springframework.stereotype.Component;

/**
 * @author zhoutg
 * @Description:
 * @date 2021-03-18 16:38
 */
@Component
public class KlTcmDiseaseFacade extends KlTcmDiseaseServiceImpl {

    /**
     * 保存中医疾病扩展表
     *
     * @param commonParam
     * @param klTcmDiseaseVO
     * @return
     */
    public boolean saveAll(CommonParam commonParam, KlTcmDiseaseVO klTcmDiseaseVO) {
        if (klTcmDiseaseVO == null) {
            return false;
        }
        // 先删除扩展表
        this.remove(new QueryWrapper<KlTcmDisease>().eq("concept_id", commonParam.getConceptId()));
        // 重新插入扩展表
        KlTcmDisease klTcmDisease = new KlTcmDisease();
        BeanUtil.copyProperties(klTcmDiseaseVO, klTcmDisease);
        klTcmDisease.setConceptId(commonParam.getConceptId());
        klTcmDisease.setGmtModified(commonParam.getNow());
        klTcmDisease.setGmtCreate(commonParam.getNow());
        klTcmDisease.setCreator(commonParam.getPerson());
        klTcmDisease.setModifier(commonParam.getPerson());
        return this.save(klTcmDisease);
    }

    public void getKlTcmDisease(Long conceptId, KlConceptAllDTO klConceptAll) {
        KlTcmDisease klTcmDisease = this.getOne(new QueryWrapper<KlTcmDisease>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", conceptId), false);
        if (klTcmDisease == null) {
            return;
        }
        KlTcmDiseaseDTO klTcmDiseaseDTO = new KlTcmDiseaseDTO();
        BeanUtil.copyProperties(klTcmDisease, klTcmDiseaseDTO);
        klConceptAll.setKlTcmDiseaseDTO(klTcmDiseaseDTO);
    }
}
