package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.KlConceptAllDTO;
import com.diagbot.dto.KlConceptSimDTO;
import com.diagbot.dto.KlVitalResultDTO;
import com.diagbot.entity.CommonParam;
import com.diagbot.entity.KlOperation;
import com.diagbot.entity.KlVitalResult;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.enums.LexiconEnum;
import com.diagbot.enums.RelationLibTypeEnum;
import com.diagbot.service.impl.KlOperationServiceImpl;
import com.diagbot.service.impl.KlVitalResultServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.vo.ConceptRelationVO;
import com.diagbot.vo.KlOperationVO;
import com.diagbot.vo.KlVitalResultVO;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @author kwz
 * @Description:
 * @date 2021-03-18 16:38
 */
@Component
public class KlVitalResFacade extends KlVitalResultServiceImpl {

    @Autowired
    KlConceptFacade klConceptFacade;


    public void getKlVitalResult(Long conceptId, KlConceptAllDTO klConceptAll) {
        KlVitalResult klVitalResult = this.getOne(new QueryWrapper<KlVitalResult>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("concept_id", conceptId), false);
        if(klVitalResult == null){
            return;
        }
        KlVitalResultDTO klVitalResultDTO = new KlVitalResultDTO();
        BeanUtil.copyProperties(klVitalResult,klVitalResultDTO);
        List<Integer> relationIdList = Lists.newArrayList(
                RelationLibTypeEnum.relationDept.getKey(),
                RelationLibTypeEnum.relationPart.getKey()
        );
        ConceptRelationVO conceptRelationVO = new ConceptRelationVO();
        conceptRelationVO.setConceptId(conceptId);
        conceptRelationVO.setRelationList(relationIdList);
        Map<Integer, List<KlConceptSimDTO>> map = klConceptFacade.getRelationConceptFac(conceptRelationVO);
        if (map.get(LexiconEnum.Part.getKey()) != null) {
            klVitalResultDTO.setPartList(map.get(LexiconEnum.Part.getKey()));
        }
        if (map.get(LexiconEnum.Dept.getKey()) != null) {
            klVitalResultDTO.setDeptList(map.get(LexiconEnum.Dept.getKey()));
        }
        klConceptAll.setKlVitalResultDTO(klVitalResultDTO);
    }
}
