package com.diagbot.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.diagbot.dto.KlConceptSimDTO;
import com.diagbot.dto.KlDrugMappingDTO;
import com.diagbot.dto.KlDrugRegisterDTO;
import com.diagbot.entity.KlDrugRegister;
import com.diagbot.mapper.KlDrugRegisterMapper;
import com.diagbot.service.KlDrugRegisterService;
import com.diagbot.vo.KlDrugMappingGetVO;
import com.diagbot.vo.KlDrugRegisterPageVO;
import com.diagbot.vo.KlDrugSearchVO;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 药品注册表 服务实现类
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-11
 */
@Service
@DS("med")
public class KlDrugRegisterServiceImpl extends ServiceImpl<KlDrugRegisterMapper, KlDrugRegister> implements KlDrugRegisterService {

    @Override
    public IPage<KlDrugRegisterDTO> getPage(KlDrugRegisterPageVO klDrugRegisterPageVO) {
        return baseMapper.getPage(klDrugRegisterPageVO);
    }

    @Override
    public List<KlDrugMappingDTO> getMappingRegister(KlDrugMappingGetVO klDrugMappingGetVO) {
        return baseMapper.getMappingRegister(klDrugMappingGetVO);
    }

    @Override
    public List<KlConceptSimDTO> getMappingDrug(KlDrugMappingGetVO klDrugMappingGetVO) {
        return baseMapper.getMappingDrug(klDrugMappingGetVO);
    }

    @Override
    public List<KlConceptSimDTO> searchDrug(KlDrugSearchVO klDrugSearchVO) {
        return baseMapper.searchDrug(klDrugSearchVO);
    }
}
