package com.diagbot.vo;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * @author wangfeng
 * @Description:
 * @date 2021-03-03 9:49
 */
@Setter
@Getter
public class KlConceptSaveVO {
    // 术语Id
    private Long conceptId;
    // libId
    private Long libId;
    @NotBlank(message = "请输入医学标准术语名称")
    private String libName;
    // 拼音
    private String spell;
    @NotNull(message = "请输入医学标准术语词性type")
    private Integer libType;
    // 同义词名称
    private String synonymName;
    @NotNull(message = "请输入状态")
    private Integer status;
    //是否标准词,1:是,0:否
    private Integer isConcept = 0;
    // 性别
    private Integer sexType;
    //是否有通用扩展(0:否;1:是)
    @NotNull(message = "请输入是否有通用扩展")
    private Integer isHasCommon;
    // 最小年龄
    private Double minAge;
    // 最大年龄
    private Double maxAge;
    // 备注
    private String remark;

    // 同义词列表
    private List<KlConceptSaveSubVO> klConceptSub;

    // 疾病扩展信息
    private KlDiseaseVO klDiseaseVO;

    // 药品通用名扩展
    private KlDrugVO klDrugVO;

    // 症状扩展信息
    private KlSymptomVO klSymptomVO;

    // 化验扩展信息
    private KlLisVO klLisVO;

    // 辅检扩展信息
    private KlPacsVO klPacsVO;

    // 手术扩展信息
    private KlOperationVO klOperationVO;

    // 体征结果扩展信息
    private KlVitalResultVO klVitalResultVO;

    // 中医疾病表
    private KlTcmDiseaseVO klTcmDiseaseVO;

    // 中医证候表
    private KlTcmSyndromeVO klTcmSyndromeVO;

}
