package com.diagbot.vo;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.diagbot.entity.Ex;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 药品注册表
 * </p>
 *
 * @author zhoutg
 * @since 2021-05-11
 */
@Data
public class KlDrugRegisterTestVO implements Serializable {

    private static final long serialVersionUID = 1L;

    @Ex(name="药品代码")
    @Excel(name="药品代码")
    private String drugCode;

    @Ex(name="注册名称")
    private String name;

    @Ex(name="英文名称")
    private String enName;

    @Ex(name="商品名称")
    private String tradeName;

    @Ex(name="注册剂型")
    private String form;

    @Ex(name="注册规格")
    private String specification;

    @Ex(name="最小包装数量")
    @Excel(name="最小包装数量")
    private String minPackQuantity;

    @Ex(name="最小包装单位")
    private String minPackUnit;

    @Ex(name="药品企业")
    private String company;

    @Ex(name="批准文号")
    private String approval;

    @Ex(name="药品本位码")
    private String standardCode;

    @Ex(name="甲乙类")
    @Excel(name="甲乙类")
    private String insuranceType;

    @Ex(name="医保备注")
    @Excel(name="医保备注")
    private String insuranceRemrk;

    @Ex(name="药品类别")
    private String drugType;

    @Ex(name="药品通用名")
    private String drugName;

}
