package com.diagbot.web;

import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.diagbot.annotation.SysLogger;
import com.diagbot.facade.TermImportFacade;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.ibatis.annotations.TypeDiscriminator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;

/**
 * @author wangfeng
 * @Description:
 * @date 2021-05-31 11:47
 */
@RestController
@RequestMapping("/importConcept")
@Api(value = "医学标准术语导入导出[by:wangfeng]", tags = { "医学标准术语导入导出API" })
@SuppressWarnings("unchecked")
public class TermImportController {
    @Autowired
    TermImportFacade termImportFacade;

    @ApiOperation(value = "医学标准术语模板导入[by:wangfeng]",
            notes = "医学标准术语模板导出[by:wangfeng]")
    @PostMapping("/exportTermExcel")
    @SysLogger("exporTermExcel")
    @DSTransactional
    public void exporTermExcel(HttpServletResponse response, @RequestParam("termfile") MultipartFile file) {
        termImportFacade.exporTermExcelAll(response, file);
    }
    @ApiOperation(value = "导出模板[by:wangfeng]",
            notes = "导出模板[by:wangfeng]")
    @PostMapping("/exportExcelTemplates")
    @SysLogger("exportExcelTemplates")
    public void exportExcelModule(HttpServletResponse response) {
        termImportFacade.exportTemplateAll(response);
    }

}
